datablock AudioProfile(DragonfireSound)
{
   filename    = "./flame_thrower_loop.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(LDragonSlashSound)
{
   filename    = "./meleeSwingsound1.wav";
   description = AudioClose3d;
   preload = true;
};
//datablock AudioProfile(LDragonBiteSound)
//{
//   filename    = "./flame_thrower_loop.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock ParticleData(DragonbreathfireParticle)
{
	dragCoefficient      = 2.5;
	gravityCoefficient   = -0.17;
	inheritedVelFactor   = 0.8;
	constantAcceleration = 0;
	lifetimeMS           = 950;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.1 0.1 1 1";
	colors[1]	= "1 0.5 0 0.5";
	colors[2]	= "1 0.25 0 0.25";
	colors[3]	= "1 0 0 0";
	sizes[0]	= 0.4;
	sizes[1]	= 1.0;
	sizes[2]	= 1.2;
	sizes[3]	= 1.5;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.8;
	times[3]	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DragonbreathfireEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DragonbreathfireParticle";

   uiName = "Dragonbreath Flame";
};

datablock ParticleData(DragonbreathambientParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = -0.25;
	inheritedVelFactor   = 0.5;
	windCoefficient      = 0.1;
	constantAcceleration = 0;
	lifetimeMS           = 900;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.3 0 0.5";
	colors[1]     = "1 0 0 0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DragonbreathambientEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DragonbreathambientParticle";

   uiName = "Dragonbreath Ambient";
};


datablock ParticleData(DragonbreathExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0 0 0.6";
	colors[1]     = "0 0 0 0";
	sizes[0]      = 0.35;
	sizes[1]      = 0.9;

	useInvAlpha = true;
};
datablock ParticleEmitterData(DragonbreathExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.5;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DragonbreathExplosionParticle";

   uiName = "Dragonbreath Burn";
};

datablock ParticleEmitterData(DragonFireBallExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 2;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DragonbreathfireParticle";

   uiName = "Fireball Explosion";
};

datablock ExplosionData(DragonbreathExplosion)
{
   lifeTimeMS = 300;

   emitter[0] = DragonbreathexplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 0;
   lightStartColor = "1 0.6 0";
   lightEndColor = "1 0.5 0";

   playerBurnTime = 5000;
};

datablock ExplosionData(DragonFireBallExplosion)
{
   lifeTimeMS = 200;

   emitter[0] = DragonFireBallexplosionEmitter;
	particleDensity = 200;
	particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

	damageRadius = 4;
	radiusDamage = 65;

	// Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 5;
   lightStartColor = "1 0.5 0";
   lightEndColor = "1 0.1 0";

   playerBurnTime = 3000;
};

///////////////////////
//Dragon Claw Effects//
///////////////////////
datablock ParticleData(LdragonMeleeSlashParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 200;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.9 0.7 0.7 0.6";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(LdragonMeleeSlashEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LdragonMeleeSlashParticle";

   uiName = "Dragon - Slash effect";
};

///////
datablock ParticleData(LdragonMeleeSmashParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 60;
   textureName          = "base/data/particles/star1";
   colors[0]     = "1.0 0.5 0.1 0.6";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 2.5;
   sizes[1]      = 6.0;
};

datablock ParticleEmitterData(LdragonMeleeSmashEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0;
   ejectionOffset   = 0.01;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LdragonMeleeSmashParticle";

   uiName = "Dragon - Smash effect";
};
