
AddDamageType("DragonFireDirect",   '<bitmap:add-ons/Player_Dragons/CI_Dragon_fire> %1',    '%2 <bitmap:add-ons/Player_Dragons/CI_Dragon_fire> %1',1,1);
AddDamageType("DragonFireballRadius",   '<bitmap:add-ons/Player_Dragons/CI_Dragon_fireRadius> %1',    '%2 <bitmap:add-ons/Player_Dragons/CI_Dragon_fireRadius> %1',1,0);

datablock ProjectileData(Dragonbreathprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 18;

	directDamageType = $DamageType::DragonFireDirect;
	radiusDamageType = $DamageType::DragonFireDirect;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 2;
   brickExplosionMaxVolumeFloating = 5;

   impactImpulse	   = 100;
   verticalImpulse	   = 0;
   explosion           = DragonbreathExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 30;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 380;
   fadeDelay           = 190;
   bounceElasticity    = 0.01;
   bounceFriction      = 0.99;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0.4 0";
};


datablock ItemData(DragonbreathItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./firebreath_ITEM.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "D - Firebreath";
	iconName = "./Icon_Fire";
	doColorShift = false;
	colorShiftColor = "1 0.25 0 1";

	 // Dynamic properties defined by the scripts
	image = DragonbreathImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DragonbreathImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   //Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = Dragonbreathprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = DragonbreathItem.colorShiftColor;

   //new energy usage thing
	energyUsage = 6;

   // Initial start up state
	stateName[0]			= "Initial";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	//stateSound[0]			= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;

	stateName[2]                    = "Charge";
	stateAllowImageChange[2]        = true;
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 1.00;
	stateWaitForTimeout[2]			= true;
	stateTransitionOnTriggerUp[2]   = "Ready";
	stateEmitter[2]			= DragonbreathambientEmitter;
	stateEmitterTime[2]		= 1.00;
	stateEmitterNode[2]		= "muzzlePoint";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateEmitter[3]			= DragonbreathfireEmitter;
	stateEmitterTime[3]		= 0.15;
	stateEmitterNode[3]		= "muzzlePoint";
	stateSound[3]			= DragonfireSound;
	stateEjectShell[3]       	= false;

	stateName[4]			= "Reload";
	stateTransitionOnTriggerUp[4]	= "Ready";
	stateTransitionOnTriggerDown[4]	= "Fire";
};

function DragonbreathImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
		%obj.playThread(1, root);
}
function DragonbreathImage::onFire(%this,%obj,%slot)
{
	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		Parent::onFire(%this,%obj,%slot);
	}
}
