datablock ItemData(DragonFireBarrageItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./firebarrage_ITEM.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "D - Firebarrage";
	iconName = "./Icon_Fire";
	doColorShift = false;
	colorShiftColor = "1 0.25 0 1";

	 // Dynamic properties defined by the scripts
	image = DragonFireBarrageImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DragonFireBarrageImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   //Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DragonFireBallprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = DragonFireBarrageItem.colorShiftColor;
   
   //new energy usage thing
   energyUsage = 100;

   // Initial start up state
	stateName[0]					= "Initial";
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	//stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]		= true;
	
	stateName[2]                    = "Charge";
	stateAllowImageChange[2]        = true;
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 2.00;
	stateWaitForTimeout[2]			= true;
	stateTransitionOnTriggerUp[2]   = "Ready";
	stateEmitter[2]					= DragonbreathambientEmitter;
	stateEmitterTime[2]				= 2.00;
	stateEmitterNode[2]				= "muzzlePoint";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Charge";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	//stateSound[3]					= DragonfireSound;
	stateEjectShell[3]       		= false;
};

function DragonFireBarrageImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
		%obj.playThread(1, root);
}

function DragonFireBarrageImage::onFire(%this,%obj,%slot)
{
	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		%projectile = %this.projectile;
		%spread = 0.003; //place spreadamount heer
		%shellcount = 5; //amount of projectiles to be fired in one shot.
		%scaleFactor = getWord(%obj.getScale(),1)/1; //better leave this be

		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getEyePoint(); //(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
			%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		}
		return %p;
	}
}
