datablock ProjectileData(DragonFireBallProjectile)
{
	shapeFile = "base/data/shapes/empty.dts";
   directDamage = 20;
   directDamageType = $DamageType::DragonFireDirect;
   radiusDamageType = $DamageType::DragonFireballRadius;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;
   brickExplosionForce = 20;
   brickExplosionMaxVolume = 10;
   brickExplosionMaxVolumeFloating = 15;

   impactImpulse = 300;
   verticalImpulse = 200;
   explosion = DragonFireBallExplosion;
   particleEmitter = DragonbreathfireEmitter;
   sound = DragonfireSound;

   muzzleVelocity = 60;
   velInheritFactor = 1;

   armingDelay = 0;
   lifetime = 4000;
   fadeDelay = 3500;
   bounceElasticity = 0.5;
   bounceFriction = 0.20;
   isBallistic = true;
   gravityMod = 0.4;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0.4 0";
};

datablock ItemData(DragonFireBallItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./fireball_ITEM.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "D - Fireball";
	iconName = "./Icon_Fire";
	doColorShift = false;
	colorShiftColor = "1 0.10 0 0.5";

	 // Dynamic properties defined by the scripts
	image = DragonFireBallImage;
	canDrop = true;
};

datablock ShapeBaseImageData(DragonFireBallImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   //Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DragonFireBallprojectile;
   projectileType = Projectile;

   melee = false;
   armReady = false;

   doColorShift = false;
   colorShiftColor = DragonFireBallItem.colorShiftColor;

   //new energy usage thing
	energyUsage = 20;

   // Initial start up state
	stateName[0]					= "Initial";
	stateTimeoutValue[0]			= 0.15;
	stateTransitionOnTimeout[0]		= "Ready";
	//stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]		= true;
	
	stateName[2]                    = "Charge";
	stateAllowImageChange[2]        = true;
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 1.00;
	stateWaitForTimeout[2]			= true;
	stateTransitionOnTriggerUp[2]   = "Ready";
	stateEmitter[2]					= DragonbreathambientEmitter;
	stateEmitterTime[2]				= 1.00;
	stateEmitterNode[2]				= "muzzlePoint";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Charge";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	//stateSound[3]					= DragonfireSound;
	stateEjectShell[3]       		= false;
};
function DragonFireBallImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
		%obj.playThread(1, root);
}
function DragonFireBallImage::onFire(%this,%obj,%slot)
{

	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		%obj.playThread(2, shiftAway);
		Parent::onFire(%this,%obj,%slot);
	}
}
