//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(AirDragonDts)
{
	baseShape  = "./AIRdragon3.dts";
	sequence0  = "./Adrag_root.dsq root";

	sequence1  = "./Adrag_run.dsq run";
	sequence2  = "./Adrag_run.dsq walk";
	sequence3  = "./Adrag_back.dsq back";
	sequence4  = "./Adrag_side.dsq side";

	sequence5  = "./Adrag_crouch.dsq crouch";
	sequence6  = "./Adrag_crouchRun.dsq crouchRun";
	sequence7  = "./Adrag_crouchBack.dsq crouchBack";
	sequence8  = "./Adrag_crouchSide.dsq crouchSide";

	sequence9  = "./Adrag_look.dsq look";
	sequence10 = "./Adrag_headside.dsq headside";
	sequence11 = "./Adrag_root.dsq headUp";

	sequence12 = "./Adrag_fly_loop.dsq jump";
	sequence13 = "./Adrag_fly_loop.dsq standjump";
	sequence14 = "./Adrag_fall.dsq fall";
	sequence15 = "./Adrag_root.dsq land";

	sequence16 = "./Adrag_root.dsq armAttack";
	sequence17 = "./Adrag_root.dsq armReadyLeft";
	sequence18 = "./Adrag_root.dsq armReadyRight";
	sequence19 = "./Adrag_root.dsq armReadyBoth";
	sequence20 = "./Adrag_root.dsq spearready";  
	sequence21 = "./Adrag_fire.dsq spearThrow";

	sequence22 = "./Adrag_root.dsq talk";  

	sequence23 = "./Adrag_death.dsq death1"; 
	
	sequence24 = "./Adrag_fire.dsq shiftUp";
	sequence25 = "./Adrag_root.dsq shiftDown";
	sequence26 = "./Adrag_fire.dsq shiftAway";
	sequence27 = "./Adrag_root.dsq shiftTo";
	sequence28 = "./Adrag_root.dsq shiftLeft";
	sequence29 = "./Adrag_root.dsq shiftRight";
	sequence30 = "./Adrag_root.dsq rotCW";
	sequence31 = "./Adrag_root.dsq rotCCW";

	sequence32 = "./Adrag_root.dsq undo";
	sequence33 = "./Adrag_fire.dsq plant";

	sequence34 = "./Adrag_sit.dsq sit";

	sequence35 = "./Adrag_root.dsq wrench";

   sequence36 = "./Adrag_fire.dsq activate";
   sequence37 = "./Adrag_fire.dsq activate2";

   sequence38 = "./Adrag_root.dsq leftrecoil";
};    

//Sounds

datablock AudioProfile(AirDragonJumpSound)
{
   fileName = "./jumpAirDragon.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DragonPainSound)
{
   fileName = "./drpain.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DragonDeathSound)
{
   fileName = "./drdeath1.wav";
   description = AudioClose3d;
   preload = true;
};

//datablock DebrisData( AirDragonDebris )
//{
 //  explodeOnMaxBounce = false;

//   elasticity = 0.15;
//   friction = 0.5;

//   lifetime = 4.0;
//   lifetimeVariance = 0.0;

//   minSpinSpeed = 40;
//   maxSpinSpeed = 600;

//   numBounces = 5;
//   bounceVariance = 0;

//   staticOnMaxBounce = true;
//   gravModifier = 1.0;

//   useRadiusMass = true;
//   baseRadius = 1;

//   velocity = 20.0;
//   velocityVariance = 12.0;
//};             

datablock PlayerData(AirDragonArmor : PlayerStandardArmor)
{
   renderFirstPerson = false;
//   emap = false;
   
//   className = Armor;
   shapeFile = "./AIRdragon3.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
   computeCRC = false;
  
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

	airControl = 1;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 2.0;

   mass = 90;
   drag = 0.6; //0.9
   density = 0.1;
   maxDamage = 270;
   maxEnergy =  150;
//   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 3000 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 6.5;
   maxBackwardSpeed = 5;
   maxSideSpeed = 5;

   maxForwardCrouchSpeed = 4;
   maxBackwardCrouchSpeed = 4;
   maxSideCrouchSpeed = 3;

//   maxForwardProneSpeed = 0;
//   maxBackwardProneSpeed = 0;
//   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 4;
   maxBackwardWalkSpeed = 4;
   maxSideWalkSpeed = 4;

   maxUnderwaterForwardSpeed = 20;
   maxUnderwaterBackwardSpeed = 20;
   maxUnderwaterSideSpeed = 20;

   jumpForce = 25 * 90; //25 * 120;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0.2;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("7.0 7.0 2.45", 4);
   crouchBoundingBox	= vectorScale("7.0 7.0 2.0", 4);

//   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = AirDragonFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
//   footPuffNumParts = 10;
//   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

//   splash = PlayerSplash;
//   splashVelocity = 4.0;
//   splashAngle = 67.0;
//   splashFreqMod = 300.0;
//   splashVelEpsilon = 0.60;
//   bubbleEmitTime = 0.1;
//   splashEmitter[0] = PlayerFoamDropletsEmitter;
//   splashEmitter[1] = PlayerFoamEmitter;
//   splashEmitter[2] = PlayerBubbleEmitter;
//   mediumSplashSoundVelocity = 10.0;   
//   hardSplashSoundVelocity = 20.0;   
//   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
//   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 90;

//   minJumpSpeed = 20;
//   maxJumpSpeed = 30;

   horizMaxSpeed = 250;
   horizResistSpeed = 180;
   horizResistFactor = 0.1;

   upMaxSpeed = 200;
   upResistSpeed = 150;
   upResistFactor = 0.1;
   
//   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

	JumpSound			= AirDragonJumpSound;

   // Footstep Sounds
//   FootSoftSound        = AirDragonFootFallSound;
//   FootHardSound        = AirDragonFootFallSound;
//   FootMetalSound       = AirDragonFootFallSound;
//   FootSnowSound        = AirDragonFootFallSound;
//   FootShallowSound     = AirDragonFootFallSound;
//   FootWadingSound      = AirDragonFootFallSound;
//   FootUnderwaterSound  = AirDragonFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
//   impactWaterEasy      = Splash1Sound;
//   impactWaterMedium    = Splash1Sound;
//   impactWaterHard      = Splash1Sound;
   
//   groundImpactMinSpeed    = 10.0;
//   groundImpactShakeFreq   = "4.0 4.0 4.0";
//  groundImpactShakeAmp    = "1.0 1.0 1.0";
//   groundImpactShakeDuration = 0.8;
//   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Dragon - Air";
	rideable = true;
		lookUpLimit = 0.6;
		lookDownLimit = 0.2;

	canRide = false;
	showEnergyBar = true;
	paintable = true;

//	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 0;
//   mountThread[0] = "root";
//   mountNode[0] = 2;

	useCustomPainEffects = true;
//	PainHighImage = "";
//	PainMidImage  = "";
//	PainLowImage  = "";
	painSound     = "DragonPainSound";
	deathSound    = "DragonDeathSound";
};

//function AirDragonArmor::onAdd(%this,%obj)
//{
   // Vehicle timeout
//   %obj.mountVehicle = true;

   // Default dynamic armor stats
//   %obj.setRepairRate(0);

//}
//called when the driver of a player-vehicle is unmounted
//function AirDragonArmor::onDriverLeave(%obj, %player)
//{
	//do nothing
//}

function AirDragonArmor::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+400)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 24");
		%obj.playThread(0, "Jump"); //animation
		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
