//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(LandDragonDts)
{
	baseShape  = "./LANDdragon4.dts";
	sequence0  = "./Ldrag_root.dsq root";

	sequence1  = "./Ldrag_run.dsq run";
	sequence2  = "./Ldrag_run.dsq walk";
	sequence3  = "./Ldrag_back.dsq back";
	sequence4  = "./Ldrag_side.dsq side";

	sequence5  = "./Ldrag_crouch.dsq crouch";
	sequence6  = "./Ldrag_crouchRun.dsq crouchRun";
	sequence7  = "./Ldrag_crouchback.dsq crouchBack";
	sequence8  = "./Ldrag_crouchSide.dsq crouchSide";

	sequence9  = "./Ldrag_look.dsq look";
	sequence10 = "./Ldrag_headside.dsq headside";
	sequence11 = "./Ldrag_root.dsq headUp";

	sequence12 = "./Ldrag_jump.dsq jump";
	sequence13 = "./Ldrag_jump.dsq standjump";
	sequence14 = "./Ldrag_fall.dsq fall";
	sequence15 = "./Ldrag_root.dsq land";

	sequence16 = "./Ldrag_root.dsq armAttack";
	sequence17 = "./Ldrag_mouthReady.dsq armReadyLeft";
	sequence18 = "./Ldrag_mouthReady.dsq armReadyRight";
	sequence19 = "./Ldrag_mouthReady.dsq armReadyBoth";
	sequence20 = "./Ldrag_root.dsq spearready";  
	sequence21 = "./Ldrag_fire1.dsq spearThrow";

	sequence22 = "./Ldrag_root.dsq talk";  

	sequence23 = "./Ldrag_death.dsq death1"; 
	
	sequence24 = "./Ldrag_fire1.dsq shiftUp";
	sequence25 = "./Ldrag_root.dsq shiftDown";
	sequence26 = "./Ldrag_fire1.dsq shiftAway";
	sequence27 = "./Ldrag_root.dsq shiftTo";
	sequence28 = "./Ldrag_root.dsq shiftLeft";
	sequence29 = "./Ldrag_root.dsq shiftRight";
	sequence30 = "./Ldrag_root.dsq rotCW";
	sequence31 = "./Ldrag_root.dsq rotCCW";

	sequence32 = "./Ldrag_root.dsq undo";
	sequence33 = "./Ldrag_fire1.dsq plant";

	sequence34 = "./Ldrag_pose.dsq sit";

	sequence35 = "./Ldrag_root.dsq wrench";

   sequence36 = "./Ldrag_fire1.dsq activate";
   sequence37 = "./Ldrag_fire1.dsq activate2";

   sequence38 = "./Ldrag_root.dsq leftrecoil";
   
   sequence39 = "./Ldrag_Rswipe.dsq LDattack1";
   sequence40 = "./Ldrag_Lslash.dsq LDattack2";
   sequence41 = "./Ldrag_FinalBite.dsq LDattack3";
   sequence42 = "./Ldrag_RswipeEND.dsq LDattack1END";
   sequence43 = "./Ldrag_LslashEND.dsq LDattack2END";
};    


//datablock AudioProfile(LandDragonJumpSound)
//{
//   fileName = "./jumpLandDragon.wav";
//   description = AudioClosest3d;
//   preload = true;
//};


//datablock DebrisData( LandDragonDebris )
//{
 //  explodeOnMaxBounce = false;

//   elasticity = 0.15;
//   friction = 0.5;

//   lifetime = 4.0;
//   lifetimeVariance = 0.0;

//   minSpinSpeed = 40;
//   maxSpinSpeed = 600;

//   numBounces = 5;
//   bounceVariance = 0;

//   staticOnMaxBounce = true;
//   gravModifier = 1.0;

//   useRadiusMass = true;
//   baseRadius = 1;

//   velocity = 20.0;
//   velocityVariance = 12.0;
//};             

datablock PlayerData(LandDragonArmor : PlayerStandardArmor)
{
   renderFirstPerson = false;
//   emap = false;
   
//   className = Armor;
   shapeFile = "./LANDdragon4.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
//   computeCRC = false;
  
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 2;

   mass = 150;
//   drag = 0.1;
//   density = 0.7;
   maxDamage = 350;
   maxEnergy =  170;
//   repairRate = 0.33;

   rechargeRate = 0.5;

   runForce = 80 * 150;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 10.5;		//old val = 8.5
   maxBackwardSpeed = 10.5;		//old val = 8.5
   maxSideSpeed = 9;			//old val = 8

   maxForwardCrouchSpeed = 4;
   maxBackwardCrouchSpeed = 3;
   maxSideCrouchSpeed = 3;

//   maxForwardProneSpeed = 0;
//   maxBackwardProneSpeed = 0;
//   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 4;
   maxBackwardWalkSpeed = 4;
   maxSideWalkSpeed = 4;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 14.5 * 120; //14 * 120;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

//   minImpactSpeed = 250;
   speedDamageScale = 10.0;

   boundingBox			= vectorScale("3.5 3.5 3.8", 4);
   crouchBoundingBox	= vectorScale("3.5 3.5 2.55", 4);

//   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = LandDragonFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
//   footPuffNumParts = 10;
//   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

//   splash = PlayerSplash;
//   splashVelocity = 4.0;
//   splashAngle = 67.0;
//   splashFreqMod = 300.0;
//   splashVelEpsilon = 0.60;
//   bubbleEmitTime = 0.1;
//   splashEmitter[0] = PlayerFoamDropletsEmitter;
//   splashEmitter[1] = PlayerFoamEmitter;
//   splashEmitter[2] = PlayerBubbleEmitter;
//   mediumSplashSoundVelocity = 10.0;   
//   hardSplashSoundVelocity = 20.0;   
//   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
//   runSurfaceAngle  = 85;
//   jumpSurfaceAngle = 86;

//   minJumpSpeed = 20;
//   maxJumpSpeed = 30;

//   horizMaxSpeed = 68;
//   horizResistSpeed = 33;
//   horizResistFactor = 0.35;

//   upMaxSpeed = 80;
//   upResistSpeed = 25;
//   upResistFactor = 0.3;
   
//   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= "";

   // Footstep Sounds
//   FootSoftSound        = LandDragonFootFallSound;
//   FootHardSound        = LandDragonFootFallSound;
//   FootMetalSound       = LandDragonFootFallSound;
//   FootSnowSound        = LandDragonFootFallSound;
//   FootShallowSound     = LandDragonFootFallSound;
//   FootWadingSound      = LandDragonFootFallSound;
//   FootUnderwaterSound  = LandDragonFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
//   impactWaterEasy      = Splash1Sound;
//   impactWaterMedium    = Splash1Sound;
//   impactWaterHard      = Splash1Sound;
   
//   groundImpactMinSpeed    = 10.0;
//   groundImpactShakeFreq   = "4.0 4.0 4.0";
//  groundImpactShakeAmp    = "1.0 1.0 1.0";
//   groundImpactShakeDuration = 0.8;
//   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 6;		//this will be controlled by mini-game code
	maxTools = 6;
	
	uiName = "Dragon - Land";
	rideable = true;
		lookUpLimit = 0.6;
		lookDownLimit = 0.6;

	canRide = false;
	showEnergyBar = true;
	paintable = true;

//	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 0;
//   mountThread[0] = "root";
//   mountNode[0] = 2;

	useCustomPainEffects = true;
//	PainHighImage = "";
//	PainMidImage  = "";
//	PainLowImage  = "";
	painSound     = "DragonPainSound";
	deathSound    = "DragonDeathSound";
};

//function LandDragonArmor::onAdd(%this,%obj)
//{
   // Vehicle timeout
//   %obj.mountVehicle = true;

   // Default dynamic armor stats
//   %obj.setRepairRate(0);

//}
//called when the driver of a player-vehicle is unmounted
//function LandDragonArmor::onDriverLeave(%obj, %player)
//{
	//do nothing
//}

//function LandDragonArmor::onTrigger(%this, %obj, %trig, %press) {
//	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+400)
//	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
//		%obj.forbidJump = true;
//		%obj.addVelocity("0 0 15");
//		%obj.playThread(0, "Jump"); //animation
//		ServerPlay3D(LandDragonJumpSound, %obj.getPosition());
//		%obj.lastjump = getsimtime();
//	}
//	else Parent::onTrigger(%this, %obj, %trig, %press);
//}

//function allowJump(%obj) {
//	if(!isObject(%obj)) 
//		return;
//	%obj.forbidJump = false;
//}
