//Weapon_Ldragon_melee.cs

datablock ExplosionData(LdragonMeleeSwipeExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = "swordHitSound";

   particleEmitter = LdragonMeleeSlashEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "2.0 2.0 2.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 0;
   lightStartColor = "1.0 0.9 0.0";
   lightEndColor = "0 0 0";
};


datablock ExplosionData(LdragonMeleeSlashExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = "swordHitSound";

   particleEmitter = LdragonMeleeSlashEmitter;
   particleDensity = 13;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 20.0";
   camShakeAmp = "50.0 15.0 2.0";
   camShakeDuration = 0.2;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 0;
   lightStartColor = "1.0 0.7 0.0";
   lightEndColor = "0 0 0";
};


datablock ExplosionData(LdragonMeleeSmashExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 400;

   soundProfile = "swordHitSound";

   particleEmitter = LdragonMeleeSmashEmitter;
   particleDensity = 6;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "22.0 24.0 20.0";
   camShakeAmp = "20.0 5.0 5.0";
   camShakeDuration = 0.6;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 0;
   lightStartColor = "1.0 0.7 0.0";
   lightEndColor = "0 0 0";

	impulseRadius = 1.5;
	impulseForce = 5000;

	damageRadius = 0.01;
	radiusDamage = 0.01;
};


// Defines the CI icon
AddDamageType("LdragonMelee",   '<bitmap:add-ons/Player_Dragons/CI_LdragonMelee> %1',    '%2 <bitmap:add-ons/Player_Dragons/CI_LdragonMelee> %1',0.75,1);

//Weak projectile
datablock ProjectileData(LdragonMeleeWeakProjectile)
{
   directDamage        = 38;
   directDamageType  = $DamageType::LdragonMelee;
   radiusDamageType  = $DamageType::LdragonMelee;
   explosion		 = LdragonMeleeSwipeExplosion;
   //particleEmitter     = ;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Dragon - Swipe";
};

//Strong projectile
datablock ProjectileData(LdragonMeleeStrongProjectile)
{
   directDamage        = 50;
   directDamageType  = $DamageType::LdragonMelee;
   radiusDamageType  = $DamageType::LdragonMelee;
   explosion		 = LdragonMeleeSlashExplosion;
   //particleEmitter     = ;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

	impactImpulse	   = 0;
	verticalImpulse	   = 0;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Dragon - Slash";
};

//Push projectile
datablock ProjectileData(LdragonMeleePushProjectile)
{
   directDamage        = 45;
   directDamageType  = $DamageType::LdragonMelee;
   radiusDamageType  = $DamageType::LdragonMelee;
   explosion		 = LdragonMeleeSmashExplosion;
   //particleEmitter     = ;

	impactImpulse	   = 0;
	verticalImpulse	   = 800;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Dragon - Bite";
};

//////////
// item //
//////////
datablock ItemData(LdragonMeleeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap =false;

	//gui stuff
	uiName = ""; //"Dragon Claws";
	iconName = "./Icon_Ldragon_slash2";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = LdragonMeleeImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(LdragonMeleeImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = swordItem;
   ammo = " ";
   projectile = LdragonMeleeWeakProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

//   minShotTime = 700;   //minimum time allowed between shots

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

	// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = LdragonMeleeDrawSound;

	// Ready State
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Slash1";
	stateAllowImageChange[1]         = true;

	// FIRST attack state
	stateName[2]					= "Slash1";
	stateScript[2]                  = "onSlash1";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.20;
	stateTransitionOnTimeout[2]     = "FightingStance1";
	stateWaitForTimeout[2]			= true;
	stateFire[2]                    = true;
	stateSound[2]                    = LDragonSlashSound;

	// -FIRST- fighting stance
	stateName[3]                    = "FightingStance1";
	stateTransitionOnTimeout[3]     = "Reset1";
	stateTimeoutValue[3]            = 0.1;
//	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
//	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= false;
	stateTransitionOnTriggerDown[3]  = "Slash2";


	// SECOND attack state
	stateName[4]					= "Slash2";
	stateScript[4]                  = "onSlash2";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.3;
	stateTransitionOnTimeout[4]     = "FightingStance2";
	stateWaitForTimeout[4]			= true;
	stateFire[4]                    = true;
	stateSound[4]                    = LDragonSlashSound;

	// -SECOND- fighting stance
	stateName[5]                    = "FightingStance2";
	stateTransitionOnTimeout[5]     = "Reset2";
	stateTimeoutValue[5]            = 0.1;
//	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
//	stateSequence[5]                = "Fire";
//	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]		= false;
	stateTransitionOnTriggerDown[5]  = "Slash3";

	// THIRD attack state
	stateName[6]					= "Slash3";
	stateScript[6]                  = "onSlash3";
	stateAllowImageChange[6]        = false;
	stateTimeoutValue[6]            = 0.4;  //5
	stateTransitionOnTimeout[6]     = "End";
	stateWaitForTimeout[6]			= true;
	stateFire[6]                    = true;
//	stateSound[6]                    = ;


	// Plays end stance 1 animation
	stateName[7]                    = "Reset1";
	stateTransitionOnTimeout[7]     = "End";
	stateTimeoutValue[7]            = 0.33;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateScript[7]                  = "onStance1Reset";

	// Plays end stance 2 animation
	stateName[8]                    = "Reset2";
	stateTransitionOnTimeout[8]     = "End";
	stateTimeoutValue[8]            = 0.33;
	stateAllowImageChange[8]        = false;
	stateWaitForTimeout[8]		= true;
	stateScript[8]                  = "onStance2Reset";

	// Reset to ready state
	stateName[9]                    = "End";
	stateTransitionOnTimeout[9]     = "Ready";
	stateTimeoutValue[9]            = 0.01;
	stateAllowImageChange[9]        = false;
	stateWaitForTimeout[9]		= false;
	stateScript[9]                  = "onEnd";

};

function LdragonMeleeImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
		%obj.playThread(1, root);
}
//-------------Slash 1---------------//
function LdragonMeleeImage::onSlash1(%this,%obj,%slot)
{
	%obj.playthread(2, LDattack1);
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

//	%projectile = %this.projectile;
	%spread = 0.001; //place spreadamount heer
	%shellcount = 1; //amount of projectiles to be fired in one shot.
	%scaleFactor = getWord(%obj.getScale(),1)/1; //better leave this be

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, LdragonMeleeWeakProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, LdragonMeleeWeakProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = LdragonMeleeWeakProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getEyePoint(); //(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	}
	return %p;
}

//-------------Slash 2---------------//
function LdragonMeleeImage::onSlash2(%this,%obj,%slot)
{
	%obj.playthread(2, LDattack2);
//	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//		return;
	%obj.lastFireTime = getSimTime();

//	%projectile = %this.projectile;
	%spread = 0.001; //place spreadamount heer
	%shellcount = 1; //amount of projectiles to be fired in one shot.
	%scaleFactor = getWord(%obj.getScale(),1)/1; //better leave this be

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, LdragonMeleeStrongProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, LdragonMeleeStrongProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = LdragonMeleeStrongProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getEyePoint(); //(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	}
	return %p;
}

//-------------Slash 3---------------//
function LdragonMeleeImage::onSlash3(%this,%obj,%slot)
{
	%obj.playthread(2, LDattack3);
//	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//		return;
	%obj.lastFireTime = getSimTime();

//	%projectile = %this.projectile;
	%spread = 0.001; //place spreadamount heer
	%shellcount = 1; //amount of projectiles to be fired in one shot.
	%scaleFactor = getWord(%obj.getScale(),1)/1; //better leave this be

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, LdragonMeleePushProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, LdragonMeleePushProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = LdragonMeleePushProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getEyePoint(); //(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
	}
	return %p;
}

//-------------Stanc1Reset---------------//
function LdragonMeleeImage::onStance1Reset(%this, %obj, %slot)
{	
		%obj.playthread(2, LDattack1END);
}

//-------------Stanc2Reset---------------//
function LdragonMeleeImage::onStance2Reset(%this, %obj, %slot)
{	
		%obj.playthread(2, LDattack2END);
}

//-------------End---------------//
function LdragonMeleeImage::onEnd(%this, %obj, %slot)
{	
		%obj.playthread(2, root);
}
